<?php

namespace Zmart\DataSource;


class ZmartNameProvider implements \Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider {

    public function getClassName($tableName) {
        return "\\Model";
    }

    /**
     * Returns a datasource instance even if there is no datasource file
     * @param string $dataSourceName
     * @return \Zeedhi\Framework\DataSource\Configuration|Configuration
     * @throws \Zeedhi\Framework\DataSource\Exception
     */
    public function getDataSourceByName($dataSourceName) {
        $ds = DIRECTORY_SEPARATOR;
        $dataSourceDirectory = realpath(__DIR__."{$ds}..{$ds}..{$ds}..{$ds}gen{$ds}datasources");
        $dataSourcePath = "{$dataSourceDirectory}{$ds}{$dataSourceName}.json";
        if (!file_exists($dataSourcePath)) {
            $configuration = Configuration::factoryFromDataSourceName($dataSourceName);
        } else {
            $configuration = Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
        }

        return $configuration;
    }
} 