import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import {ChartViewService} from "@/Services/ChartViewService";

export class Column extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        return charts;
    }
    public setMask(charts: any) {
        if (charts[0].options.yAxis.axisLabel && charts[0].options.yAxis.maskFunction) {
            const maskFunction = ChartViewService.getMaskFunction(charts[0].options.yAxis.maskFunction);
            charts[0].options.yAxis.axisLabel.formatter = maskFunction;
            charts[0].options.tooltip.valueFormatter = maskFunction;
            charts[0].options.series.forEach((serie: any) => {
                if (serie.label) {
                    serie.label.formatter = this.setMaskSerie.bind(this, maskFunction);
                }
            });
            charts[0].options.tooltip.valueFormatter = maskFunction;
        }
    }

    public setMaskSerie(maskFunction: any, param: any) {
        return maskFunction(param.value);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
       this.setMask(charts);
        charts[0].events = {
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }

    public getEditData(viewData: any) {
        if (Array.isArray(viewData.serieColors)) {
            viewData.originSerieColors = viewData.serieColors;
        }
        return viewData;
    }

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        if (values.chartXAxisBandDimensionGap) {
            cleanValues.chartXAxisBandDimensionGap = parseFloat(cleanValues.chartXAxisBandDimensionGap);
        }
        if (values.chartXAxisBandDimensionMinWidth) {
            cleanValues.chartXAxisBandDimensionMinWidth = parseFloat(cleanValues.chartXAxisBandDimensionMinWidth);
        } else {
            cleanValues.chartXAxisBandDimensionMinWidth = 1;
        }
        if (values.chartXAxisTicksMaxWidth) {
            cleanValues.chartXAxisTicksMaxWidth = parseFloat(cleanValues.chartXAxisTicksMaxWidth);
        } else {
            delete cleanValues.chartXAxisTicksMaxWidth;
        }
        if (values.chartXAxisTicksRotation) {
            cleanValues.chartXAxisTicksRotation = parseFloat(cleanValues.chartXAxisTicksRotation);
        }
        if (values.chartLegendMargin) {
            cleanValues.chartLegendMargin = parseFloat(cleanValues.chartLegendMargin);
        } else {
            cleanValues.chartLegendMargin = null;
        }
        if (!cleanValues.chartSeries[0].serieValueFormat) {
            delete cleanValues.chartSeries[0].serieValueFormat;
        }
        cleanValues.chartSeries[0].serieType = 'bar';
        cleanValues.serieType = 'bar';
        return cleanValues;
    }
}
